package com.nisum.example.config;

import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.ObjectWriter;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.reactive.config.EnableWebFlux;

@Configuration
@EnableWebFlux
public class ApiConfig {

    @Bean
    public ObjectMapper getObjectMapper(){ //ObjectMapper allows to convert java obj into json and viceversa
        ObjectMapper objectMapper=new ObjectMapper();
        objectMapper.registerModule(new JavaTimeModule());
        objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES,false)
                .configure(SerializationFeature.WRITE_DATE_KEYS_AS_TIMESTAMPS,true);
        return objectMapper;
    }

    @Bean
    public ObjectWriter getObjectWriter(ObjectMapper objectMapper){ //objectwriter gives json response in readable format
        return objectMapper.writerWithDefaultPrettyPrinter();

    }
}
