package com.nisum.example.model;

import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;
import lombok.RequiredArgsConstructor;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;

import java.time.LocalDate;

/**
 * Model class for Reservation
 * having required fields
 */
@Data
@NoArgsConstructor
@RequiredArgsConstructor
@Document
public class Reservation {
    @Id
    private String id;
    @NonNull
    private Long roomNumber;
    @NonNull
    private LocalDate checkIn;
    @NonNull
    private LocalDate checkOut;
    @NonNull
    private Integer price;


}
